package com.liang.dao;

import com.liang.entity.BaseCompany;
import com.liang.entity.SysDeptInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseCompany)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-15 23:13:17
 */
public interface BaseCompanyDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseCompany queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param baseCompany 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<BaseCompany> queryAllByLimit(BaseCompany baseCompany, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseCompany 查询条件
     * @return 总行数
     */
    long count(BaseCompany baseCompany);

    /**
     * 新增数据
     *
     * @param baseCompany 实例对象
     * @return 影响行数
     */
    int insert(BaseCompany baseCompany);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseCompany> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseCompany> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseCompany> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseCompany> entities);

    /**
     * 修改数据
     *
     * @param baseCompany 实例对象
     * @return 影响行数
     */
    int update(BaseCompany baseCompany);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取单位列表
     *
     * @return
     */
    List<BaseCompany> getBaseCompanyList(Map map);

    /**
     * 新建单位
     *
     * @param baseCompany
     * @return
     */
    int doAdd(BaseCompany baseCompany);

    /**
     * 校验单位全称是否唯一
     *
     * @param dwqc
     * @return
     */
    int checkCompanyUnique(String dwqc);

    /**
     * 批量删除
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);
}

